// Scintilla source code edit control
// scintilla-ext.cxx - This file provides access to the widget services required by
//                     code outside(aka "EXTernal") of the widget implementation
// Copyright (c) 2013 Mentor Graphics Corporation
// The license.terms file describes the conditions under which this software may be distributed.

#ifndef _SCINTILLA_EXT
#define _SCINTILLA_EXT

#include <tcl.h>
#include <tk.h>
#include "Scintilla.h"

// the following constant is used to allow the widget code to preserve
// point sizes set by Tk which use a negative value(to indicate pixels)
#define MAGIC_FONT_OFFSET 1000

// The description for indicators says that roundbox, squarebox, and dotbox are transparent overlay of text, this is
// expensive to do. Better performance is achieved with solid color fill under the text at the expense of loosing the
// darker outline effect and partial obscuring of the text. If you want transparent overlays for indicators, change the
// value of the following definition to 0 (zero).
#define USE_SOLID_INDICATORS 1

#ifdef SCI_NAMESPACE
using namespace Scintilla;
#endif

// create out namespace
namespace TkSciExt {

int  GetMarginWidth (ClientData d);
void SetPixmap      (ClientData d, Pixmap p);
void SetYScrollDelta(ClientData d, int delta);
void UpdateForScroll(ClientData d);

void MSG_SetCursor  (ClientData d, int cursor_id);
void MSG_LinesAdded (ClientData d, int line, int added);
void MSG_Modified (ClientData d);
void MSG_MoveUpdate (ClientData d);
void MSG_SyncXScroll(ClientData d);
void MSG_SyncYScroll(ClientData d);

}//--- end of TkSciExt namespace
#endif
